#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform vec4 v_offset;
uniform vec4 v_smooth;

const vec4 GRAY = vec4(0.2126, 0.7152, 0.0722, 0.00390625);
const mat3 SEPIA = mat3(
	0.393, 0.769, 0.189,
	0.349, 0.686, 0.168,
	0.272, 0.534, 0.131
);

void main()
{
	vec4 col = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
	if (col.a <= GRAY.a) discard;
	// vec4 g = vec4(vec3(dot(col.rgb, GRAY.rgb)) * 0.75, col.a);
	vec3 x = vec3(dot(col.rgb, GRAY.rgb) * v_smooth.x);
	vec4 g = vec4(mix(x, x * SEPIA, v_smooth.y), col.a);
	float s = sin(v_texCoord.x * v_offset.z + v_offset.x) * v_offset.w + v_offset.y;
	// gl_FragColor = s > v_texCoord.y ? g : col;
	// gl_FragColor = mix(col, g, clamp((s - v_texCoord.y) * 85.0, 0.0, 1.0));
	gl_FragColor = mix(col, g, smoothstep(v_smooth.z, v_smooth.w, s - v_texCoord.y));
}
